# SPDX-License-Identifier: (GPL-2.0 OR BSD-2-Clause)
%YAML 1.2
---
$id: http://devicetree.org/schemas/hwmon/maxim,max31790.yaml#
$schema: http://devicetree.org/meta-schemas/core.yaml#

title: The Maxim MAX31790 Fan Controller

maintainers:
  - Guenter Roeck <linux@roeck-us.net>
  - Chanh Nguyen <chanh@os.amperecomputing.com>

description: >
  The MAX31790 controls the speeds of up to six fans using six
  independent PWM outputs. The desired fan speeds (or PWM duty cycles)
  are written through the I2C interface.

  Datasheets:
    https://datasheets.maximintegrated.com/en/ds/MAX31790.pdf

properties:
  compatible:
    enum:
      - maxim,max31785
      - maxim,max31785a
      - maxim,max31785b
      - maxim,max31790

  reg:
    maxItems: 1

  clocks:
    maxItems: 1

  resets:
    maxItems: 1

  '#address-cells':
    const: 1

  '#size-cells':
    const: 0

  "#pwm-cells":
    const: 1

patternProperties:
  "^fan@[0-9]+$":
    $ref: fan-common.yaml#
    unevaluatedProperties: false

required:
  - compatible
  - reg

additionalProperties: false

examples:
  - |
    i2c {
      #address-cells = <1>;
      #size-cells = <0>;

      pwm_provider: fan-controller@20 {
        compatible = "maxim,max31790";
        reg = <0x20>;
        clocks = <&sys_clk>;
        resets = <&reset 0>;
        #address-cells = <1>;
        #pwm-cells = <1>;
        #size-cells = <0>;

        fan@0 {
          reg = <0x0>;
          pwms = <&pwm_provider 1>;
        };

        fan@1 {
          reg = <0x1>;
          pwms = <&pwm_provider 2>;
        };
      };
    };

